<?php
class Shipping extends Shipping_Object
{
	private $client;
	private $status = array(
		1 => 1,//'معلق',
		2 => 2,//'آماده به ارسال',
		4 => 3,//'ارسال شده',
		5 => 4,//'توزیع شده',
		6 => 5,//'وصول شده',
		7 => 6,//'برگشتی',
		3 => 0,//'انصرافی',
	);
	
	public function __construct()
	{
		if(extension_loaded('soap')) {
			$options = array('login'=> MAHA_LOGIN,'password'=> MAHA_PASSWORD);
			try {
				$this->client = new SoapClient("http://webservice.mahacod.com/cod.wsdl",$options);
			} catch (Exception $e) {
				try {
					# workaround for php 5.3 bug!
					if(!file_exists(CACHE_PATH.'mahacod_webservice.xml')) {
						$xml = file_get_contents('http://webservice.mahacod.com/cod.wsdl');
						file_put_contents(CACHE_PATH.'mahacod_webservice.xml',$xml);
					}
					$this->client = new SoapClient(CACHE_PATH.'mahacod_webservice.xml',$options);
					$this->url = 'http://webservice.mahacod.com/cod.wsdl';
				} catch (Exception $e) {
					// error
				}
			}
		} else
			Error::view(0,'Soap Extension Required');
	}
	
	public function getPrice($send_type,$price,$weight,$state_id,$city_id,$discount)
	{	
		$ap_param = array('ostan_maghsad'=>$state_id,
                'shahr_maghsad'=>$city_id,
                'send_type'=>$send_type,
                'products_weight'=>$weight,
                'total_price'=>$price-$discount);
		$info = $this->client->__soapCall("calculation_send_price", $ap_param);
		$res['send'] = $info->send_price;
		$res['service'] = $info->maliyat + $info->khadamat + $info->codprice;
		return $res;
	}
	
	/*private function send_type($type)
	{
		if($type==1)
			$post_type = 1; #sefareshi
		elseif($type==2)
			$post_type = 2; #pishtaz
		return $post_type;
	}*/
	
	public function submitOrder($order,$items)
	{
		$product_array = array();
		foreach($items as $prod) {
			$arr = array(
				'p_id'=>$prod['cod_id'],
				'p_title'=>$prod['title'],
		        'p_weight'=>$prod['weight'],
		        'p_price'=>(int)($prod['price'] - ($prod['price']*$prod['discount']/100)),
		        'p_number'=>$prod['qty']
		    );
		    $product_array[] = implode('^',$arr);
		}
		$ap_param = array(
			'o_name'=>$order['name'],
			'o_family'=>$order['family'],
			'o_phone'=>$order['phone'],
			'o_mobile'=>$order['mobile'],
			'o_email'=>$order['email'],
			'o_postalcod'=>$order['zipcode'],
			'o_ostan'=>(int)$order['state_id'],
			'o_shahr'=>(int)$order['city_id'],
			'o_address'=>$order['address'],
			'o_message'=>$order['comment'],
			'o_sendtype'=>(int)$order['send_type'],
			'o_product_list'=>implode(";",$product_array),
			'o_ip_address'=>$_SERVER["REMOTE_ADDR"]
		);
		$info = $this->client->__soapCall("insert_order", $ap_param);
		if(strlen(@$info->order_code) > 10)
			return $info->order_code;
		else
			return false;
	}
	
	public function regions()
	{
		$state = '<script type="text/javascript" src="http://webservice.mahacod.com/download/city.js"></script>
<p>استان : <select id="field_state_id" name="state_id" onchange="GetCity(this.selectedIndex);">
<option value="0">لطفا استان خود را انتخاب کنید</option>
<option value="41">آذربايجان شرقي</option>
<option value="44">آذربايجان غربي</option>
<option value="45">اردبيل</option>
<option value="31">اصفهان</option>
<option value="84">ايلام</option>
<option value="77">بوشهر</option>
<option value="21">تهران</option>
<option value="38">چهارمحال بختياري</option>
<option value="56">خراسان جنوبي</option>
<option value="51">خراسان رضوي</option>
<option value="58">خراسان شمالي</option>
<option value="61">خوزستان</option>
<option value="24">زنجان</option>
<option value="23">سمنان</option>
<option value="54">سيستان و بلوچستان</option>
<option value="71">فارس</option>
<option value="28">قزوين</option>
<option value="25">قم</option>
<option value="87">كردستان</option>
<option value="34">كرمان</option>
<option value="83">كرمانشاه</option>
<option value="74">كهكيلويه و بويراحمد</option>
<option value="17">گلستان</option>
<option value="13">گيلان</option>
<option value="66">لرستان</option>
<option value="15">مازندران</option>
<option value="86">مركزي</option>
<option value="76">هرمزگان</option>
<option value="81">همدان</option>
<option value="35">يزد</option>
<option value="26">البرز</option>
</select></p>
<p>شهر : <select name="city_id" id="citylist"><option selected value="">لطفا استان خود را انتخاب کنید</option></select></p>';
		  Template::set('custom_cod_condition','$(\'#field_state_id\').val() && $(\'#citylist\').val()');
		  Template::set('custom_cod_js',"
		var state = \$('#field_state_id').val();
		var city = \$('#citylist').val();
		var url = 'order/price/'+$('#field_buy_type').val()+'/'+\$('#field_send_type').val()+'/'+state+'/'+city+'/0/'+\$('#field_coupon').val()+'/';");
		  return $state;
	}
	
	public function get_state($order)
	{
		$states = array(
			41 => 'آذربايجان شرقي',
			44 => 'آذربايجان غربي',
			45 => 'اردبيل',
			31 => 'اصفهان',
			84 => 'ايلام',
			77 => 'بوشهر',
			26 => 'البرز',
			21 => 'تهران',
			38 => 'چهارمحال بختياري',
			56 => 'خراسان جنوبي',
			51 => 'خراسان رضوي',
			58 => 'خراسان شمالي',
			61 => 'خوزستان',
			24 => 'زنجان',
			23 => 'سمنان',
			54 => 'سيستان و بلوچستان',
			71 => 'فارس',
			28 => 'قزوين',
			25 => 'قم',
			87 => 'كردستان',
			34 => 'كرمان',
			83 => 'كرمانشاه',
			74 => 'كهكيلويه و بويراحمد',
			17 => 'گلستان',
			13 => 'گيلان',
			66 => 'لرستان',
			15 => 'مازندران',
			86 => 'مركزي',
			76 => 'هرمزگان',
			81 => 'همدان',
			35 => 'يزد',
		);
		if(isset($states[$order['state_id']]))
			return $states[$order['state_id']];
		else
			return false;
	}
	
	public function get_city($order)
	{
		$cities = array(
			1 => 'آذر شهر',
			2 => 'اسكو',
			3 => 'اهر',
			4 => 'بستان آباد',
			5 => 'بناب',
			6 => 'بندر شرفخانه',
			7 => 'تبريز',
			8 => 'تسوج',
			9 => 'جلفا',
			10 => 'سراب',
			11 => 'شبستر',
			12 => 'عجبشير',
			13 => 'قره آغاج',
			14 => 'كليبر',
			15 => 'كندوان',
			16 => 'مرند',
			17 => 'ملكان',
			18 => 'ميانه',
			19 => 'مراغه',
			20 => 'هاديشهر',
			21 => 'هشترود',
			22 => 'هريس',
			23 => 'ورزقان',   
			24 => 'اروميه',
			25 => 'اشنويه',
			26 => 'بوكان',
			27 => 'تكاب',
			28 => 'پيرانشهر',
			29 => 'پلدشت',
			30 => 'چالدران',
			31 => 'خوي',
			32 => 'سر دشت',
			33 => 'سلماس',
			34 => 'شاهين دژ',
			35 => 'شوط',
			36 => 'چايپاره',
			37 => 'ماكو',
			38 => 'مهاباد',
			39 => 'مياندوآب',
			40 => 'نقده',     
			41 => 'اردبيل',
			42 => 'بيله سوار',
			43 => 'پارس آباد',
			44 => 'خلخال',
			45 => 'سرعين',
			46 => 'كوثر',
			47 => 'كيوي',
			48 => 'گرمي',
			49 => 'مشگين شهر',
			50 => 'مغان',
			51 => 'نمين',
			52 => 'نير',      
			53 => 'آران و بيدگل',
			54 => 'اردستان',
			55 => 'اصفهان',
			56 => 'باغ بهادران',
			57 => 'تيران',
			58 => 'خميني شهر',
			59 => 'خوانسار',
			60 => 'زرين شهر',
			61 => 'سميرم',
			62 => 'شاهين شهر',
			63 => 'شهرضا',
			64 => 'فريدن',
			65 => 'فريدون شهر',
			66 => 'فلاورجان',
			67 => 'فولاد شهر',
			68 => 'كاشان',
			69 => 'گلپايگان',
			70 => 'مباركه',
			71 => 'نايين',
			72 => 'نجف آباد',
			73 => 'نطنز',     
			74 => 'آبدانان',
			75 => 'ايلام',
			76 => 'ايوان',
			77 => 'دره شهر',
			78 => 'دهلران',
			79 => 'سرابله',
			80 => 'شيروان چرداول',
			81 => 'مهران',    
			82 => 'اهرم',
			83 => 'بوشهر',
			84 => 'تنگستان',
			85 => 'خارك',
			86 => 'خورموج',
			87 => 'دير',
			88 => 'دشتستان',
			89 => 'دشتي',
			90 => 'ديلم',
			91 => 'ريشهر',
			92 => 'كنگان',
			93 => 'گناوه',    
			104 => 'اسلامشهر',
			105 => 'بومهن',
			106 => 'تجريش',
			107 => 'تهران',
			108 => 'پاكدشت',
			109 => 'دماوند',
			110 => 'رباط كريم',
			111 => 'ري',
			112 => 'رودهن',
			113 => 'شريف آباد',
			114 => 'شهريار',
			115 => 'فشم',
			116 => 'فيروزكوه',
			117 => 'قدس',
			118 => 'قرچك',
			119 => 'كن',
			120 => 'كهريزك',
			121 => 'گلستان',
			122 => 'لواسان',
			123 => 'ملارد',
			124 => 'ورامين',  
			125 => 'اردل',
			126 => 'بروجن',
			127 => 'چلگرد',
			128 => 'سامان',
			129 => 'شهركرد',
			130 => 'فارسان',
			131 => 'لردگان',  
			159 => 'آشخانه',
			160 => 'اسفراين',
			161 => 'بجنورد',
			162 => 'جاجرم',
			163 => 'شيروان',  
			132 => 'بيرجند',
			133 => 'بشرويه',
			134 => 'خضري',
			135 => 'سربيشه',
			136 => 'قائن',
			137 => 'نهبندان',
			138 => 'فردوس',   
			139 => 'بردسكن',
			140 => 'تايباد',
			141 => 'تربت جام',
			142 => 'تربت حيدريه',
			143 => 'چناران',
			144 => 'خواف',
			145 => 'درگز',
			146 => 'سبزوار',
			147 => 'سرخس',
			148 => 'طبس',
			149 => 'طرقبه',
			150 => 'فريمان',
			151 => 'قوچان',
			152 => 'كاخك',
			153 => 'كلات',
			154 => 'كاشمر',
			155 => 'گناباد',
			156 => 'مشهد',
			157 => 'نيشابور',
			158 => 'رشتخوار', 
			164 => 'آبادان',
			165 => 'اميديه',
			166 => 'انديمشك',
			167 => 'اهواز',
			168 => 'ايرانشهر',
			169 => 'ايذه',
			170 => 'باغ ملك',
			171 => 'بندرامام خميني',
			172 => 'بندر ماهشهر',
			173 => 'بهبهان',
			174 => 'دزفول',
			175 => 'خرمشهر',
			176 => 'رامهرمز',
			177 => 'سوسنگرد',
			178 => 'شادگان',
			179 => 'شوش',
			180 => 'شوشتر',
			181 => 'لالي',
			182 => 'مسجد سليمان',
			183 => 'هنديجان',
			184 => 'هويزه',   
			185 => 'ابهر',
			186 => 'ايجرود',
			187 => 'خرمدره',
			188 => 'زنجان',
			189 => 'قيدار',
			190 => 'طارم',
			191 => 'ماهنشان', 
			192 => 'ايوانكي',
			193 => 'بسطام',
			194 => 'سمنان',
			195 => 'شاهرود',
			196 => 'دامغان',
			197 => 'گرمسار',  
			198 => 'ايرانشهر',
			199 => 'چابهار',
			200 => 'خاش',
			201 => 'راسك',
			202 => 'زابل',
			203 => 'زاهدان',
			204 => 'سراوان',
			205 => 'سرباز',
			206 => 'ميرجاوه',
			207 => 'نيكشهر',  
			208 => 'آباده',
			209 => 'اردكان',
			210 => 'ارسنجان',
			211 => 'استهبان',
			212 => 'اقليد',
			213 => 'جهرم',
			214 => 'حاجي آباد',
			215 => 'خرم بيد',
			216 => 'داراب',
			217 => 'سپيدان',
			218 => 'سوريان',
			219 => 'شيراز',
			220 => 'صفاشهر',
			221 => 'فراشبند',
			222 => 'فسا',
			223 => 'فيروز آباد',
			224 => 'قيروكارزين',
			225 => 'كازرون',
			226 => 'لار',
			227 => 'لامرد',
			228 => 'مرودشت',
			229 => 'ممسني',
			230 => 'مهر',
			231 => 'ني ريز',
			232 => 'نورآباد', 
			233 => 'آبيك',
			234 => 'بوئين زهرا',
			235 => 'تاكستان',
			236 => 'قزوين',
			237 => 'الوند',   
			238 => 'قم',      
			239 => 'بانه',
			240 => 'بيجار',
			241 => 'ديواندره',
			242 => 'سقز',
			243 => 'سنندج',
			244 => 'قروه',
			245 => 'كامياران',
			246 => 'مريوان',  
			247 => 'بابك',
			248 => 'بافت',
			249 => 'بردسير',
			250 => 'بم',
			251 => 'جيرفت',
			252 => 'راور',
			253 => 'رفسنجان',
			254 => 'زرند',
			255 => 'سيرجان',
			256 => 'كهنوج',
			257 => 'كرمان',   
			258 => 'اسلام آباد غرب',
			259 => 'پاوه',
			260 => 'جوانرود',
			261 => 'سر پل ذهاب',
			262 => 'سنقر',
			263 => 'صحنه',
			264 => 'قصر شيرين',
			265 => 'كرمانشاه',
			266 => 'كنگاور',
			267 => 'گيلان غرب',
			268 => 'هرسين',   
			269 => 'دنا',
			270 => 'دوگنبدان',
			271 => 'دهدشت',
			272 => 'سي سخت',
			273 => 'گچساران',
			274 => 'ياسوج',   
			275 => 'آزاد شهر',
			276 => 'آق قلا',
			277 => 'بندر گز',
			278 => 'تركمن',
			279 => 'راميان',
			280 => 'علي آباد كتول',
			281 => 'كلاله',
			282 => 'كردكوي',
			283 => 'گنبد كاووس',
			284 => 'گرگان',
			285 => 'مينو دشت',
			286 => 'آستانه اشرفيه',
			287 => 'آستارا',
			288 => 'املش',
			289 => 'بندرانزلي',
			290 => 'تالش',
			291 => 'رشت',
			292 => 'رضوان شهر',
			293 => 'رودبار',
			294 => 'رستم آباد',
			295 => 'رود سر',
			296 => 'سياهكل',
			297 => 'شفت',
			298 => 'صومعه سرا',
			299 => 'فومن',
			300 => 'كلاچاي',
			301 => 'لاهيجان',
			302 => 'لنگرود',
			303 => 'ماسال',
			304 => 'ماسوله',
			305 => 'منجيل',
			306 => 'هشتپر',
			307 => 'ازنا',
			308 => 'الشتر',
			309 => 'اليگودرز',
			310 => 'بروجرد',
			311 => 'پلدختر',
			312 => 'خرم آباد',
			313 => 'دزفول',
			314 => 'دورود',
			315 => 'كوهدشت',
			316 => 'ماهشهر',
			317 => 'نور آباد',
			318 => 'شول آباد',
			319 => 'آمل',
			320 => 'بابل',
			321 => 'بابلسر',
			322 => 'بلده',
			323 => 'بهشهر',
			324 => 'پل سفيد',
			325 => 'تنكابن',
			326 => 'ساري',
			327 => 'سواد كوه',
			328 => 'جويبار',
			329 => 'چالوس',
			330 => 'رامسر',
			331 => 'فريدون كنار',
			332 => 'قائم شهر',
			333 => 'محمود آباد',
			334 => 'نكا',
			335 => 'نور',
			336 => 'نوشهر',
			337 => 'آشتيان',
			338 => 'اراك',
			339 => 'تفرش',
			340 => 'خمين',
			341 => 'دليجان',
			342 => 'ساوه',
			343 => 'سربند',
			344 => 'سربند',
			345 => 'شازند',
			346 => 'محلات',
			347 => 'ابوموسي',
			348 => 'انگهران',
			349 => 'بستك',
			350 => 'بندر جاسك',
			351 => 'بندرعباس',
			352 => 'بندر لنگه',
			353 => 'تنب بزرگ',
			354 => 'حاجي آباد',
			355 => 'دهبارز',
			356 => 'قشم',
			357 => 'كيش',
			358 => 'ميناب',
			359 => 'بندر خمير',
			360 => 'اسدآباد',
			361 => 'بهار',
			362 => 'تويسركان',
			363 => 'رزن',
			364 => 'كبودر آهنگ',
			365 => 'ملاير',
			366 => 'نهاوند',
			367 => 'همدان',
			368 => 'ابركوه',
			369 => 'اردكان',
			370 => 'اشكذر',
			371 => 'بافق',
			372 => 'تفت',
			373 => 'طبس',
			374 => 'مهريز',
			375 => 'ميبد',
			376 => 'هرات',
			377 => 'يزد',
			94 => 'كرج',
			95 => 'آسارا',
			96 => 'اشتهارد',
			97 => 'هشتگرد',
			98 => 'كوهسار',
			99 => 'چهارباغ',
			100 => 'طالقان',
			101 => 'جوستان',
			102 => 'نظرآباد',
			103 => 'تنكمان',
		);
		
		if(isset($cities[$order['city_id']]))
			return $cities[$order['city_id']];
		else
			return false;
	}
	
	public function getOrderStatus($order)
	{
		try{
			$ap_param = array(
				'order_id'=>$order['code'],
			);
			$info = $this->client->__soapCall("get_status", $ap_param);
			if(isset($this->status[$info->status_code]))
				return $this->status[$info->status_code];
			else
				return false;
		} catch (SoapFault $sf) {
			return false;
		}
	}
}