<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<base href="{=site_url}" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
{IF meta_description}<meta http-equiv="description" content="{=meta_description}" />{ENDIF}
{IF meta_keyword}<meta http-equiv="keywords" content="{=meta_keyword}" />{ENDIF}
<script src="template/core/jquery-latest.min.js" type="text/javascript"></script>
<script src="template/core/jquery.jcarousel.min.js" type="text/javascript"></script>
<script src="template/core/jquery.cycle.all.min.js" type="text/javascript"></script>
<script src="template/core/jquery.easing.1.3.min.js" type="text/javascript"></script>
<script src="template/core/core.js" type="text/javascript"></script>
<script src="template/shop/{=theme_id}/script.js" type="text/javascript"></script>
{template_files}
<link rel="stylesheet" type="text/css" href="template/shop/{=theme_id}/style.css" />
<title>{=shop_title} - {=title_for_layout}</title>
</head>

<body>
<div align="center">
	<div class="layout">
		<div class="white round-5 header">
			<h1>{=shop_title}</h1>
		</div>
		<div class="navbar round-5 white shadow">
			<ul class="hul">
				{show_links_1}
				<li class="search">
					<form action="product/search/">
					<input type="text" name="q" onfocus="$(this).val('');" value="جستجو" class="input round-5 right" /> <input type="submit" value="" class="search-button left" />
					</form>
				</li>
				<div class="cb"></div>
			</ul>
		</div>
		<div class="right sidebar">
			
			<div class="white2 menu">
				<div class="ttl">منوی اصلی</div>
				<div class="pd-10">
					<ul class="vul">
						{show_links_2}
					</ul>
				</div>
			</div>
			<div class="orange menu" id="cart_menu">
				<div class="ttl">سبد خرید</div>
				<div class="pd-10">
					<div class="cart_count right">
						<a href="cart/view" id="cart_count">{cart_count}</a>
					</div>
					<div class="left cart_links">
						<div class="item"><a href="cart/view" class="button orange">نمایش</a></div>
						<div class="item"><a href="cart/clear" class="button orange">خالی کردن</a></div>
						<div class="item"><a href="order/submit" class="button orange">ثبت سفارش</a></div>
					</div>
					<div class="cb"></div>
				</div>
			</div>
			<div class="white2 menu">
				<div class="ttl">دسته بندی ها</div>
				<div class="pd-10">
					{show_ml_cats}
				</div>
			</div>
			<div class="white2 menu">
				<div class="ttl">آخرین محصولات</div>
				<div class="pd-10">
					{show_new_products_10}
				</div>
			</div>
		</div>
		<div class="left content">
			<div class="inner" id="container">
			{IF !is_home}
				<div class="round-10 white shadow mgb-10">
					<div class="ttl">{=title_for_layout}</div>
					<div class="pd-10" id="content-wrapper">
					{IF error}
						<div class="error">
						{=error}
						</div>
					{ENDIF}
			{ENDIF}
					{IF product_view}
						<div class="prod">
							<div class="text">
								{=product['text']}
							</div>
							<div class="data">
								<p class="info">{=product['info']}</p>
								<o><span>قیمت : </span>{=product['price']} {=currency}</p>
							</div>
							<ul class="tags">
								<li>برچسب ها : </li>
								{LOOP tags AS tag}
								<li><a href="product/search/?q={=tag}">{=tag}</a></li>
								{ENDLOOP}
							</ul>
							<div class="cb"></div>
							<div class="links">
								{IF stock}<a class="green button" href="cart/add/{=product['id']}/1">افزودن به سبد خرید</a>{ELSE}موجود نیست{ENDIF}
							</div>
						</div>
					{ENDIF}
					{IF products_index}
						{IF news}
						<div id="news" class="round-10 shadow">
							<a id="news_archive" href="news/index" title="آرشیو اخبار"></a>
							<ul>
							{LOOP news AS _news}
								<li><a href="news/view/{=_news['slug']}">{=_news['title']}</a></li>
							{ENDLOOP}
							</ul>
						</div>
						{ENDIF}
						<div class="products">
						{IF !products}
							<div class="white round-10 shadow mgb-10">
								<div class="pd-10">
									محصولی یافت نشد !
								</div>
							</div>
						{ELSE}
							{LOOP products AS product}
							<div class="product prod">
								<div class="p_inner round-5">
									<div class="img right">
										<img src="upload/product_thumb_{=product['id']}.jpg" width="150" height="200" alt="{=product['title']}" />
									</div>
									<div class="left">
										<div class="title"><a href="product/view/{=product['id']}">{=product['title']}</a></div>
										<div class="desc">{=product['short_text']}</div>
										<div class="data">
											<div class="info">{=product['info']}</div>
										</div>
										<div class="price"><span>قیمت : </span>{=product['price']} {=currency}</div>
										<div class="links">
											<a class="left orange button" href="product/view/{=product['id']}">توضیحات</a>
											<a class="right orange button" href="cart/add/{=product['id']}/1">افزودن به سبد خرید</a>
										</div>
									</div>
									<div class="cb"></div>
								</div>
							</div>
							{ENDLOOP}
							<div class="cb"></div>
							{=pagination}
						{ENDIF}
						</div>
					{ENDIF}
					{IF other_pages}
						{=content_for_layout}
					{ENDIF}
				{IF !is_home}
					</div>
				</div>
			{ENDIF}
				<div class="cb"></div>
				<div class="white shadow menu offers mgt-10">
					<div class="ttl round-10">{=offer_title}</div>
					<div class="pd-10">
						<ul class="vul right">
							{LOOP offer_prods AS prod}
							<li id="offer_{=prod['id']}">
								<a href="product/view/{=prod['id']}" onmouseover="offer_info({=prod['id']})">{=prod['title']}</a>
							</li>
							{ENDLOOP}
						</ul>
						<div id="offer_info" class="left">
						
						</div>
						<div class="cb"></div>
					</div>
				</div>
				<div class="cb"></div>
			</div>
		</div>
		<div class="cb"></div>
		<div class="footer round-5 white shadow">
			<div class="logos"></div>
			<!-- HAZF NASHAVAD -->
			{show_copyright}
			<!-- HAZF NASHAVAD -->
		</div>
	</div>
</div>
</body>
</html>